VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CEnumFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'local variable(s) to hold property value(s)
Private mvarPath As String 'local copy
Private mvarFiles As Collection 'local copy

'buffers for Path and Filter to prevent reparsing on every call
Dim asPath() As String

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

Private Const MAX_PATH = 260
Private Const MAXDWORD = &HFFFF
Private Const INVALID_HANDLE_VALUE = -1

Private Const FILE_ATTRIBUTE_ARCHIVE = &H20
Private Const FILE_ATTRIBUTE_COMPRESSED = &H800
Private Const FILE_ATTRIBUTE_DIRECTORY = &H10
Private Const FILE_ATTRIBUTE_HIDDEN = &H2
Private Const FILE_ATTRIBUTE_NORMAL = &H80
Private Const FILE_ATTRIBUTE_READONLY = &H1
Private Const FILE_ATTRIBUTE_SYSTEM = &H4
Private Const FILE_ATTRIBUTE_TEMPORARY = &H100

Private Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
        dwFileAttributes As Long
        ftCreationTime As FILETIME
        ftLastAccessTime As FILETIME
        ftLastWriteTime As FILETIME
        nFileSizeHigh As Long
        nFileSizeLow As Long
        dwReserved0 As Long
        dwReserved1 As Long
        cFileName As String * MAX_PATH
        cAlternate As String * 14
End Type









Public Property Set Files(ByVal vData As Collection)
'used when assigning an Object to the property, on the left side of a Set statement.
'Syntax: Set x.Files = Form1
    Set mvarFiles = vData
End Property


Public Property Get Files() As Collection
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Files
    Set Files = mvarFiles
End Property



Public Property Let Path(ByVal vData As String)
Attribute Path.VB_Description = "Define th e root from which to recurse files."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Path = 5
    mvarPath = vData
    asPath = Split(vData, "|")
    Refresh
End Property


Public Property Get Path() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Path
    Path = mvarPath
End Property




Private Sub RecurseDirectory(Path As String)
'in order to prevent stack overflows, don't recurse function, store all directories in collection
Dim cDirs As New Collection, cFiles As New Collection
cDirs.Add Path

Dim hFindFile As Long, ffd As WIN32_FIND_DATA
Dim lRetVal As Long, sCurDir As String, sFilename As String

Do While cDirs.Count > 0
    sCurDir = cDirs.Item(1)
    cDirs.Remove 1
    
    hFindFile = FindFirstFile(GetFileName("*.*", sCurDir), ffd)
    If hFindFile = INVALID_HANDLE_VALUE Then
        lRetVal = 0
    Else
        lRetVal = hFindFile
    End If
    
    Do Until lRetVal = 0
        lRetVal = FindNextFile(hFindFile, ffd)
        If lRetVal <> 0 Then
            sFilename = StripNulls(ffd.cFileName)
            If sFilename <> "." And sFilename <> ".." Then
                If ffd.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY Then
                    'dir, add to local stack (collection)
                    cDirs.Add GetFileName(sFilename, sCurDir)
                Else
                    'file, add to output (directly for optimal performance)
                    mvarFiles.Add GetFileName(sFilename, sCurDir)
                End If
            End If
        End If
    Loop
    FindClose hFindFile
Loop
End Sub
Private Function GetFileName(Filename As String, Path As String) As String
If Right(Path, 1) <> "\" Then
    GetFileName = Path & "\" & Filename
Else
    GetFileName = Path & Filename
End If
End Function



Private Function StripNulls(s As String) As String
Dim iPos As Integer
iPos = InStr(1, s, vbNullChar, 0)
If iPos <> 0 Then StripNulls = Left(s, iPos - 1)
End Function

Public Sub Refresh()
Attribute Refresh.VB_Description = "Refresh the file list"
Set mvarFiles = New Collection
Dim i As Integer
For i = LBound(asPath) To UBound(asPath)
    If asPath(i) <> "" Then RecurseDirectory (asPath(i))
Next i
End Sub
